/* ADK to MML by Chris Covell (chris_covell@yahoo.ca) */
/* Ugg. I've really gotten out of the C programming habit. */
/* Look upon my works, dar'st thou, and despair! Or rewrite a better version. */

#include <stdio.h>
#include <string.h>

static unsigned char Hex[16] =
{
   '0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F'
};

unsigned char A;
unsigned char nextbyte;
unsigned int version;
FILE *F,*O;
unsigned char Buf[256];
unsigned char FNAME[]="ADK-00-0.txt\0";
unsigned char LB,HB,B;
unsigned int SngBase=0,SngPtr=0,TrkPtr=0;
unsigned int i,j,jend,k,Sane;
unsigned int note=0, combine=1,opened=0, reverse=0;


unsigned int get16(FILE*);
unsigned int ADKMML_Write(FILE*,FILE*);


int main(int argc,char *argv[])
{
   fprintf(stdout,"\nADK to MML v0.3 by Chris Covell\nReads in an ADK Sound ROM, spits out info / MML\n\n");
  /* If no arguments given, print out help message */ 
  if(argc<2)
  {
    fprintf(stdout,"   Usage: %s file.bin [-s] [-r]\n\n",argv[0]);
    fprintf(stdout,"   [-s] separates each MML track to its own file\n");
    fprintf(stdout,"   [-r] reverses '<' and '>' octave commands \n\n");
    return(1);
  }
  if (argc>=3)
   for (j=3;j<=argc;j++) /* read all arguments to set flags */
   {
       if (!strncmp(argv[j-1],"-s",2))
       {
              combine=0;     /* option to Separate all files! */
       }
       if (!strncmp(argv[j-1],"-r",2))
       {
              reverse=1;     /* option to Reverse < and > meanings */
       }
   }
  
  /* Open the ROM image */
  if(!(F=fopen(argv[1],"rb")))
  {
    fprintf(stdout,"%s: Can't open binary image '%s'\n",argv[0],argv[1]);
    return(2);
  }
  
  fseek(F,0x70,SEEK_SET); /* Go to Text Strings */
  Sane=1;
  fread(Buf,1,60,F);
  Buf[60]=0;
  fprintf(stdout,Buf);
  fread(Buf,1,4,F);
  Buf[4]=0;
  version=Buf[0]-0x30;
  fprintf(stdout,Buf);
  printf("\n");
  fread(Buf,1,80,F);
  Buf[80]=0;
  fprintf(stdout,Buf);
  printf("\n");
  
  if((version>7)||(version<1))
  {
  fclose(F);
  fprintf(stdout,"Invalid or Unsupported version #%d \n",version);  
  return(-1);
  }
  
  if (version<6) fseek(F,0x200,SEEK_SET);     /* track location for V 1.2-3.5 */
  if (version==6) fseek(F,0x2C00,SEEK_SET);    /* track location for V 6.4 / 6.5 */
  if (version>6) fseek(F,0x2E00,SEEK_SET);     /* track location for V 7.3 */
  SngBase=get16(F);
  printf("Song addresses start at $%X\n",SngBase);
  
  fseek(F,SngBase,SEEK_SET);
  SngPtr=get16(F);
  printf("Track data starts at $%X\n",SngPtr);
  
  j=0;
  jend=(SngPtr-SngBase)/24;                   /* 12 sets of WORDS */
  printf("$%X tracks total\n",jend);
  fseek(F,SngBase,SEEK_SET);
  
  while((j<jend) && Sane)
      {
       opened=0;
  
      for(i=0;i<12;i++)
      {
        fseek(F,(SngBase+(i*2)+(j*24)),SEEK_SET);
        TrkPtr=get16(F);
        if(TrkPtr)      /* if pointer is non-zero */
        {
          fseek(F,TrkPtr,SEEK_SET);      /* jump to data now */
          A=fgetc(F);                       /* get 1st byte! */
          if (A<0xFF)                       /* if terminator, do nada */
          {
           FNAME[7]=Hex[i];              /* alter the filename for each track */
           FNAME[4]=Hex[j/16];
           FNAME[5]=Hex[j&0x0F];

           
            if(combine==0 || i<1 || i==10) /* if "combine" switched on, combine FM tracks */
            {           
              if(!(O=fopen(FNAME,"w")))
              {
              fprintf(stdout,"%s: Can't open file for writing.\n",argv[0]);
              return(5);
              }
            }
            if((combine==1) && (i<10) && (i>3) && (opened==0)) /* if "combine" switched on, combine PCM tracks */
            {           
              if(!(O=fopen(FNAME,"w")))
              {
              fprintf(stdout,"%s: Can't open file for writing.\n",argv[0]);
              return(5);
              }
              opened=1; /* stop opening new file for next time */
            }

            
            printf("Song %X Track %X at %X\n",j,i,TrkPtr);
            while (A<0xFF)
            {             
                  note=ADKMML_Write(F,O);
                  /*if (!skip)*/
                  A=fgetc(F);
            }
            fprintf(O,";\n");
            if(combine==0 || i==3 || i>=9) fclose(O); /* if "combine" on, close file only 3,9,10... */                                 
                                            
          }
        }  
      }
      
      j=j+1;
      }

      fclose(F);  

  /* Done */
  return(0);
}



unsigned int get16(FILE *F)
{
  unsigned char LBin,HBin;
  LBin=fgetc(F);
  HBin=fgetc(F);
  return (LBin & 0xff)+256*(HBin & 0xff);   
}

unsigned int ADKMML_Write(FILE* F,FILE* O)
{
   switch(A)
   {
      case 'R':                    /* Notes or Rest */
      case 'A':
      case 'B':
      case 'C':
      case 'D':
      case 'E':
      case 'F':
      case 'G':
      {
         fputc(' ',O);
         fputc(A+('a'-'A'),O);         
         return 1;               /* "Note precedes next value!" flag */
      }
      case 'V':                    /* Vn - Volume v - for FM, scale down! */
      {
         fprintf(O,"\n");
         nextbyte=fgetc(F);
         fputc(A+('a'-'A'),O);
         if (i==10)
         {
                   fprintf(O,"%d ",nextbyte>>4);
         }          
         else if (i>3)
         {
                 fprintf(O,"%d ",nextbyte>>1);
         }
         else fprintf(O,"%d ",nextbyte>>4);
         fprintf(O,"  // V $%X \n",nextbyte);
         return 0;
      }
      case 'U':                    /* Un - Volume v - Master for PCM, scale down! */
      {
         fprintf(O,"\n");
         nextbyte=fgetc(F);
         fputc('v',O);
         fprintf(O,"%d ",nextbyte>>2);
         fprintf(O,"  // U $%X \n",nextbyte);
         return 0;
      }
      case 'O':                    /* On - Octave o */
      {
         nextbyte=fgetc(F);
         fputc(A+('a'-'A'),O);
         fprintf(O,"%d ",nextbyte+1);
         return 0;
      }
      
      
      case 'T':                    /* Tn - Tempo t */
      case 'Q':                    /* Qn - Quantize q */
      {
         nextbyte=fgetc(F);
         fputc(A+('a'-'A'),O);
         fprintf(O,"%d ",nextbyte);
         return 0;
      }
      case 'X':                    /* Sample HIT */
      {
         fputc('c',O);
         /* fprintf(O,"\n"); */
         return 1;
      }
      
      case '[':                    /* [n - Loop Count */
      {
         nextbyte=fgetc(F);
         fputc(A,O);
         fprintf(O,"%d ",nextbyte);
         return 0;
      }
      case '#':                    /* # - Sharp + */
      {
         fputc('+',O);
         return 0;
      }
      case 'b':                    /* b - Flat - */
      {
         fputc('-',O);
         return 0;
      }
      case '+':                    /* + - Quartertone up */
      {
         fprintf(O,"+ // 1/4 tone +\n");
         return 0;
      }
      case '-':                    /* - - Quartertone down - */
      {
         fprintf(O,"- // 1/4 tone -\n");
         return 0;
      }
      case 't':                    /* t - 3/8 tone up */
      {
         fprintf(O,"+ // 3/8 tone +\n");
         return 0;
      }
      case 'u':                    /* u - 3/8 tone down */
      {
         fprintf(O,"- // 3/8 tone -\n");
         return 0;
      }
      case 'o':                    /* o - 1/8 tone up */
      {
         fprintf(O," //o - 1/8 tone +\n");
         return 0;
      }
      case 'q':                    /* q - 1/8 tone down */
      {
         fprintf(O," //q - 1/8 tone -\n");
         return 0;
      }
           
      case '_':                    /* _n - "NOP" for 1 count */
      {
         nextbyte=fgetc(F);
         fputc('^',O);
         fprintf(O,"%d ",nextbyte);
         return 0;
      }
      case '(':                    /* Start of looping track */
      {
         fputc('$',O);
         return 0;
      }
      case ')':                    /* End of looping track */
      {
         fprintf(O,"\n//')' Track Loop End\n");
         return 0;
      }
      
      
      case 'l':                    /* l - left chan */
      case 'r':                    /* r - right chan */
      case 's':                    /* s - stereo */      
      {
         fprintf(O,"\n// ");
         fputc(A,O);
         fprintf(O," \n");
         return 0;
      }
      
      case '$':                    /* $ - sequence loop start */    
      {
         fprintf(O,"[\n // ");
         fputc(A,O);
         fprintf(O," \n");
         return 0;
      }
      case '%':                    /* % - sequence loop end */      
      {
         fprintf(O,"\n // ");
         fputc(A,O);
         fprintf(O," \n");
         return 0;
      }
      
      case '*':                    /* *n - Loop start/break??? */
      {
         nextbyte=fgetc(F);
         fprintf(O,"\n|  // *%d \n",nextbyte);
         return 0;
      }
     
      case '?':                    /* ?n - FM instrument no. */
      case '|':                    /* |n - Loop start/break? */

      case 'f':                    /* fn - FM LFO Frequency */
      case 'v':                    /* vn - FM Vibrato */
      case 'a':                    /* an - FM Tremolo */
      case 'S':                    /* Sn - PM sense (PMS) direct write */
      case 'Z':                    /* Zn - FM Release Rate */
      case 'p':                    /* pn - Pitch bend of some type */
      {
         nextbyte=fgetc(F);
         fprintf(O,"\n// ");
         fputc(A,O);
         fprintf(O,"%d \n",nextbyte);
         return 0;
      }

      case '<':        //* $3C */                    
      case '>':        //* $3E */
      {
         fputc((A^(reverse<<1)),O); /* if "reverse" chosen, swaps < and > */
         return 0;
      }

      case '.':     /* pass through other commands */
      {
         fputc(A,O);
         return 0;
      }
      case ']':
      {
         fputc(A,O);
         fprintf(O,"\n");
         return 0;
      }
      case '{':                    /* {n - Another loop counter */
      {
         nextbyte=fgetc(F);
         fputc('[',O);
         fprintf(O,"%d ",nextbyte);
         return 0;
      }
      case '}':
      {
         fputc(']',O);
         return 0;
      }
      
      case 0x01:                    /* Binary note lengths */
      case 0x02:
      case 0x04:
      case 0x08:
      case 0x10:
      case 0x20:
      case 0x40:
      case 0x03:
      case 0x06:
      case 0x0C:
      case 0x18:
      case 0x30:
      case 0x60:
      case 0xC0:
      {
         /* if (!note) fputc('l',O);  if a note/rest directly precedes it, it's the length!!! */  
         fprintf(O," l%d",A);
         A=fgetc(F);   /* check for dot */
         if (A!='.') fputc(' ',O);
         fseek(F,-1,SEEK_CUR);       /* back up 1 byte */
         return 0;
      }
   }
   return 0;           
}
