/* MML to ADK by Chris Covell (chris_covell@yahoo.ca) */
/* Ugg. I've really gotten out of the C programming habit. */
/* Look upon my works, dar'st thou, and despair! Or rewrite a better version. */

#include <stdio.h>
#include <string.h>

static unsigned char Hex[16] =
{
   '0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F'
};

unsigned char A;
int Ain;
unsigned char nextbyte;
unsigned int version;
FILE *F,*O;
unsigned char Buf[4];
unsigned char FNAME[]="ADKMML-0.asm\0";
unsigned char LB,HB,MB,B;
unsigned int SngBase=0,SngPtr=0,TrkPtr=0;
unsigned int i,j,jend,k,Sane,Param;
unsigned int note=0, nocomments=0,opened=0, mute=0, newline=1, wasnum=0, waschar=0;
unsigned int separate=0, length=4, reverse=0, passcomments=0, defer=0, loopon=0;


unsigned char getA(FILE*);
unsigned int get16(FILE*);
unsigned int getnum(FILE*);
unsigned int outchar(unsigned char, FILE* O);
unsigned int outnum(unsigned short int, FILE* O);
unsigned int ADKMML_Write(FILE*,FILE*);
unsigned int PrtHeader(FILE* O);


int main(int argc,char *argv[])
{
   fprintf(stdout,"\nMML to ADK v0.3 by Chris Covell\nReads in a well-behaved MML file, spits out ADKMML ASM source\n\n");
  /* If no arguments given, print out help message */ 
  if(argc<2)
  {
    fprintf(stdout,"   Usage: %s file.bin [-s] [-r] [-c]\n\n",argv[0]);
    fprintf(stdout,"   [-s] separates each track to its own .ASM file\n");
    fprintf(stdout,"   [-r] reverses '<' and '>' octave commands \n");
    fprintf(stdout,"   [-c] passes comments through as data *BE CAREFUL!*\n\n");
    return(1);
  }
  if (argc>=3)
   for (j=3;j<=argc;j++) /* read all arguments to set flags */
   {
       if (!strncmp(argv[j-1],"-s",2))
       {
              separate=1;     /* option to separate files */
       }
       if (!strncmp(argv[j-1],"-r",2))
       {
              reverse=1;     /* option to Reverse < and > meanings */
       }
       if (!strncmp(argv[j-1],"-c",2))
       {
              passcomments=1;     /* option to pass Comments through as data */
       }
   }
      
  Sane=1;
  j=0;
  FNAME[7]=Hex[j&0x0F];
  Buf[0]=' ';
  Buf[1]=' ';
  Buf[2]=' ';
  Buf[3]=' ';
  
  /* Open the ROM image */
  if(!(F=fopen(argv[1],"r")))
  {
    fprintf(stdout,"%s: Can't open binary image '%s'\n",argv[0],argv[1]);
    return(2);
  }
  
  if(!(O=fopen(FNAME,"wb")))
  {
       fprintf(stdout,"%s: Can't open file for writing.\n",argv[0]);
       return(5);
  }
    

  fprintf(O,"\n ;track %X \n",j);
  defer=0;
  
  while(Sane)
  {
             A=getA(F);
             /* if ((Sane) && (!mute)) fputc(A,O); */
             note=ADKMML_Write(F,O);
  }
  fclose(O);
  fclose(F);
  
    /* Done */
  return(0);
}
  

unsigned char getA(FILE *F)
{
  Ain=fgetc(F);
  if (Ain == EOF)
  {
          Sane = 0;
  }
  return (Ain & 0xff);   
}

unsigned int get16(FILE *F)
{
  unsigned char LBin,HBin;
  LBin=fgetc(F);
  HBin=fgetc(F);
  return (LBin & 0xff)+256*(HBin & 0xff);   
}

unsigned int getnum(FILE *F)
{
  B=fgetc(F);
  if ((B>='0') && (B<='9'))
  {
     Param = (B-0x30);
     B=fgetc(F);
     if ((B>='0') && (B<='9'))
     {
      Param = (Param*10)+(B-0x30);
      B=fgetc(F);
      if ((B>='0') && (B<='9'))
      {
       Param = (Param*10)+(B-0x30);
       /* return 0; */
      }
      else fseek(F,-1,SEEK_CUR);       /* back up 1 byte */
     }
     else fseek(F,-1,SEEK_CUR);       /* back up 1 byte */                  
  }
  else fseek(F,-1,SEEK_CUR);       /* back up 1 byte */
  return 0;          
}

unsigned int outchar(unsigned char A2, FILE* O)
{
         if (newline)
         {
                     PrtHeader(O);
                     fprintf(O," .db \"");
                     newline=0;
         }
         else
         {
                     if (wasnum)
                     {
                                fprintf(O,", \"");
                                wasnum=0;
                     }                     
         }
         fputc(A2,O);
         waschar=1;
         return 0;
}

unsigned int outnum(unsigned short int N2, FILE* O)
{
         if (newline)
         {
                     PrtHeader(O);
                     fprintf(O," .db %d ",N2);
                     newline=0;
         }
         else
         {
                     if (waschar)
                     {
                                fprintf(O,"\", %d ",N2);
                                waschar=0;
                     }
                     else if (wasnum)
                     {
                                fprintf(O,", %d ",N2);
                     }                     
         }
         wasnum=1;
         return 0;
}

unsigned int PrtHeader(FILE* O)
{
  if (defer)          /* open a new file & write track # only if more data to write */
  {
   if (separate)
   {
    if(!(O=fopen(FNAME,"wb")))
    {
     fprintf(stdout,"Can't open file for writing.\n");
     Sane=0;
     return(5);
    }
   }
  fprintf(O,"\n ;track %X \n",j);             
  }
  defer=0;
  return 0;         
}

unsigned int ADKMML_Write(FILE* F,FILE* O)
{
   if (mute)
   {
            switch(A)
            {
             case 0x0D:
             case 0x0A:
             {
              fputc(A,O);
/*              fputc('\n',O);*/
                newline=1;
                wasnum=0;
                waschar=0;
              mute=0;
              return 0;
             }
             case '/':
             {
                  if((!nocomments)&&(passcomments==0)) fprintf(O," ;");
                  if((!nocomments)&&(passcomments==1)) fprintf(O," ");                 
                  return 0;
             }     
                  
             
             default:
             {
                     if(!nocomments) fputc(A,O);
                     return 0;       
             }
            }
   }
   
   
            
   else
   {
    switch(A)
    {
      case ' ':
      {
           return 0;
      }
      case '/':
      {
           PrtHeader(O);    /* comments will have to be printed in the new file... */
           mute=1;
           return 0;     
      }
      
      case 0x0D:
      case 0x0A:
      {
           if(!defer)    /* newlines ignored if the file is closed. */
           {
            if (waschar) fprintf(O,"\"");
            fputc(A,O);
           }
           wasnum=0;
           waschar=0;
           mute=0;
           newline=1;
           return 0;
      }     
      

      case 'r':                    /* Notes or Rest */
      case 'a':
      case 'b':
      case 'c':
      case 'd':
      case 'e':
      case 'f':
      case 'g':
      case 'R':
      case 'A':
      case 'B':
      case 'C':
      case 'D':
      case 'E':
      case 'F':
      case 'G':
      {
         if((j>3 && j<10)&&(A != 'r')) A='x'; /* for ADPCM-A samples! */
         Buf[0]=A&0xDF;            /* copy our note temporarily, convert to upper-case */
         Buf[1]=0;
         A=getA(F);           /* check next space for + or - */
         if (A=='+') Buf[1]='#';
         else if(A=='-') Buf[1]='b';
         else fseek(F,-1,SEEK_CUR);       /* back up 1 byte */
         
         /* Next, check next byte for number / length!! */
         A=getA(F);
         if((A>='0')&&(A<='9'))
         {
              /* TEMP NOTE LENGTH NOW FOLLOWS! */
              fseek(F,-1,SEEK_CUR);       /* back up 1 byte */
              getnum(F);
              outnum(Param,O);            /* print temp length */
              
              A=getA(F);                  /* check for dot */
              if (A=='.') outchar('.',O);
              else fseek(F,-1,SEEK_CUR);       /* back up 1 byte */
              
              outchar(Buf[0],O);     /* print our note */
              if (Buf[1]>0x20) outchar(Buf[1],O);
              
              outnum(length,O);             /* then restore default length */
         }
         else 
         {
              fseek(F,-1,SEEK_CUR);       /* back up 1 byte */       
              outchar(Buf[0],O);
              if (Buf[1]>0x20) outchar(Buf[1],O);
         }
         
         return 1;               /* "Note precedes next value!" flag */
      }

      
      case 't':
      case 'q':
      case 'T':
      case 'Q':
      {
         outchar(A&0xDF,O);
         getnum(F);
         outnum(Param,O);
         return 0;
      }
      
      case 'l':
      case 'L':
      {
         getnum(F);
         length=Param;
         outnum(Param,O);
         return 0;
      }
      
      case 'o':
      case 'O':
      {
         outchar('O',O);
         getnum(F);
         outnum(Param-1,O);
         return 0;
      }
      
      case 'v':
      case 'V':
      {
         outchar('V',O);
         getnum(F);
         if (j<4) outnum(Param*8,O);
         else outnum(Param,O);
         return 0;
      }
      
      case '[':
      {
         outchar(A,O);
         getnum(F);
         outnum(Param,O);
         return 0;
      }      
      

      case '<':        //* $3C */                    
      case '>':        //* $3E */
      {
         outchar((A^(reverse<<1)),O);      /* if "reverse" chosen, swaps < and > */
         return 0;
      }

      case '$':
      {
         if(!loopon)outchar('(',O);
         else outchar(A,O);
         loopon=loopon+1;
         return 0;
      }      

      case '.':
      case ']':
      {
         outchar(A,O);
         return 0;
      }
      
      case '+':
      {
         outchar('#',O);
         return 0;
      }
      
      case '-':
      {
         outchar('b',O);
         return 0;
      }
      
      case '^':
      {
         outchar('_',O);
         getnum(F);
         outnum(Param,O);
         return 0;
      }
      
      case ';':
      {
           PrtHeader(O);
           if (waschar)
           {
                       fprintf(O,"\"");
                       waschar=0;
           }
           wasnum=0;
           fprintf(O,"\n .db"); 
           if(loopon) fprintf(O," \")\",");
           fprintf(O," -1   ;end of ");
           if(loopon) fprintf(O,"looping ");
           fprintf(O,"track %X \n\n",j);
           newline=1;
           loopon=0;
           j=j+1;
           length=4;     /* reset default note length */
           FNAME[7]=Hex[j&0x0F];
           defer=1;
           if (separate)
           {
                          fclose(O);                      
           }
           /* PrtHeader(O); NOT HERE! */
           return 0;
      }
      
    }
   } 
   return 0;           
}
